import zxcvbn from 'zxcvbn';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var VuePasswordStrength$1 = { render: function render() {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { class: _vm.inputGroupClass }, [_c('div', { class: _vm.aboveInputClass }, [_c('label', { class: _vm.labelClass, attrs: { "for": _vm.id } }, [_vm._v(_vm._s(_vm.labelText) + "}")]), _vm._v(" "), _c('div', { class: _vm.passwordStrengthClass }, [_c('div', { class: [_vm.passwordStrengthInnerClass, _vm.getScoreColorClass], style: { 'width': _vm.getWidthByScore } })])]), _vm._v(" "), _vm.type === 'checkbox' ? _c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.password, expression: "password" }], class: _vm.inputClass, attrs: { "id": _vm.id, "placeholder": _vm.placeholder, "required": _vm.required, "type": "checkbox" }, domProps: { "value": _vm.value, "checked": Array.isArray(_vm.password) ? _vm._i(_vm.password, _vm.value) > -1 : _vm.password }, on: { "input": _vm.calculateScore, "change": function change($event) {
          var $$a = _vm.password,
              $$el = $event.target,
              $$c = $$el.checked ? true : false;if (Array.isArray($$a)) {
            var $$v = _vm.value,
                $$i = _vm._i($$a, $$v);if ($$el.checked) {
              $$i < 0 && (_vm.password = $$a.concat([$$v]));
            } else {
              $$i > -1 && (_vm.password = $$a.slice(0, $$i).concat($$a.slice($$i + 1)));
            }
          } else {
            _vm.password = $$c;
          }
        } } }) : _vm.type === 'radio' ? _c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.password, expression: "password" }], class: _vm.inputClass, attrs: { "id": _vm.id, "placeholder": _vm.placeholder, "required": _vm.required, "type": "radio" }, domProps: { "value": _vm.value, "checked": _vm._q(_vm.password, _vm.value) }, on: { "input": _vm.calculateScore, "change": function change($event) {
          _vm.password = _vm.value;
        } } }) : _c('input', { directives: [{ name: "model", rawName: "v-model", value: _vm.password, expression: "password" }], class: _vm.inputClass, attrs: { "id": _vm.id, "placeholder": _vm.placeholder, "required": _vm.required, "type": _vm.type }, domProps: _defineProperty({ "value": _vm.value }, 'value', _vm.password), on: { "input": [function ($event) {
          if ($event.target.composing) {
            return;
          }_vm.password = $event.target.value;
        }, _vm.calculateScore] } })]);
  }, staticRenderFns: [], _scopeId: 'data-v-6c9df38e',
  name: 'DHKPasswordInput',
  props: {
    /**
    * Input and label-for id.
    * Default is 'input-password'
    * @type {String}
    */
    id: {
      type: String,
      default: 'input-password'
    },
    /**
    * Input type.
    * Default is password.
    * @type {String}
    */
    type: {
      type: String,
      default: 'password'
    },
    /**
    * Input placeholder.
    * Default is 'Enter your password'.
    * @type {String}
    */
    placeholder: {
      type: String,
      default: 'Enter your password'
    },
    /**
    * Input value.
    * @type {String}
    */
    value: {
      type: String
    },
    /**
    * Input field required flag.
    * Default is false.
    * @type {Boolean}
    */
    required: {
      type: Boolean,
      default: false
    },
    /**
    * Text displayed in the label.
    * Default is 'Password'.
    * @type {String}
    */
    labelText: {
      type: String,
      default: 'Password'
    },
    /**
    * CSS Classname for overall container.
    * Default is 'dhk-password-input'.
    * @type {String}
    */
    inputGroupClass: {
      type: String,
      default: 'dhk-password-input'
    },
    /**
    * CSS Classname for wrapper around the
    * label and password strength indicator.
    * Default is 'dhk-password-above-input'.
    * @type {String}
    */
    aboveInputClass: {
      type: String,
      default: 'dhk-password-above-input'
    },
    /**
    * CSS Classname for the label element.
    * Default is 'dhk-input-label'.
    * @type {String}
    */
    labelClass: {
      type: String,
      default: 'dhk-input-label'
    },
    /**
    * CSS Classname for the input element.
    * Default is 'dhk-input'.
    * @type {String}
    */
    inputClass: {
      type: String,
      default: 'dhk-input'
    },
    /**
    * CSS Classname for password strength indicator container.
    * Default is 'dhk-password-strength-container'.
    * @type {String}
    */
    passwordStrengthClass: {
      type: String,
      default: 'dhk-password-strength-container'
    },
    /**
    * CSS Classname for password strength indicator 
    * inner div element (this div displays the color).
    * Default is 'dhk-password-strength-inner'.
    * @type {String}
    */
    passwordStrengthInnerClass: {
      type: String,
      default: 'dhk-password-strength-inner'
    }
  },
  data: function data() {
    return {
      password: '',
      score: 0
    };
  },

  computed: {
    /**
    * Generates the width of the scorebar.
    * @return {String} Width of scorebar in percentage.
    */
    getWidthByScore: function getWidthByScore() {
      return this.score * 25 + '%';
    },


    /**
    * Generates the correct classname to display the right color for each score.
    * @return {String} Classname for backgroundcolor.
    */
    getScoreColorClass: function getScoreColorClass() {
      var classPrefix = 'dhk-score-color-';
      var classSuffix = this.score === 1 ? 'dark-red' : this.score === 2 ? 'red' : this.score === 3 ? 'orange' : this.score === 4 ? 'green' : 'blank';
      return classPrefix + classSuffix;
    }
  },
  methods: {
    /**
    * Calculates the score using zxcvbn and emits the score, user input.
    * Also emits the feedback if there is any.
    */
    calculateScore: function calculateScore() {
      var calculation = zxcvbn(this.password);
      this.score = calculation.score;

      this.$emit('score', calculation.score);
      this.$emit('inputChange', this.password);

      if (calculation.feedback.warning || calculation.feedback.suggestions.length) {
        this.$emit('feedback', calculation.feedback);
      }
    }
  }
};

export default VuePasswordStrength$1;
